<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: bit_stream_kernel_1.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_eb2de9fe2621acbfe407d8dd6ec7aeb5.html">bit_stream</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">bit_stream_kernel_1.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2003  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_BIT_STREAM_KERNEl_1_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_BIT_STREAM_KERNEl_1_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;bit_stream_kernel_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;iosfwd&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;{</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classdlib_1_1bit__stream__kernel__1.html">   12</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1bit__stream__kernel__1.html">bit_stream_kernel_1</a></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    {</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classdlib_1_1bit__stream__kernel__1.html#acacd3c0985a8c03ca04fc3b5dd51d770">   48</a></span>&#160;        <a class="code" href="classdlib_1_1bit__stream__kernel__1.html#acacd3c0985a8c03ca04fc3b5dd51d770">bit_stream_kernel_1</a> (</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        ) :</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;            write_mode(false),</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            read_mode(false)</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        {}</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="classdlib_1_1bit__stream__kernel__1.html">bit_stream_kernel_1</a> (</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        )</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        {}</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordtype">void</span> clear (</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        );</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordtype">void</span> set_input_stream (</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            std::istream&amp; is</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        );</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keywordtype">void</span> set_output_stream (</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            std::ostream&amp; os</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        );</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keywordtype">void</span> close (</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        );</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">bool</span> is_in_write_mode (</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">bool</span> is_in_read_mode (</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">void</span> write (</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            <span class="keywordtype">int</span> bit</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        );</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordtype">bool</span> read (</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            <span class="keywordtype">int</span>&amp; bit</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        );</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            <a class="code" href="classdlib_1_1bit__stream__kernel__1.html#acacd3c0985a8c03ca04fc3b5dd51d770">bit_stream_kernel_1</a>&amp; item</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        );</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keyword">private</span>:</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            <span class="comment">// member data</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            std::istream* isp;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            std::ostream* osp;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            <span class="keywordtype">bool</span> write_mode;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;            <span class="keywordtype">bool</span> read_mode;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> buffer;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> buffer_size;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            </div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            <span class="comment">// restricted functions</span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            <a class="code" href="classdlib_1_1bit__stream__kernel__1.html#acacd3c0985a8c03ca04fc3b5dd51d770">bit_stream_kernel_1</a>(<a class="code" href="classdlib_1_1bit__stream__kernel__1.html#acacd3c0985a8c03ca04fc3b5dd51d770">bit_stream_kernel_1</a>&amp;);        <span class="comment">// copy constructor</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <a class="code" href="classdlib_1_1bit__stream__kernel__1.html#acacd3c0985a8c03ca04fc3b5dd51d770">bit_stream_kernel_1</a>&amp; operator=(<a class="code" href="classdlib_1_1bit__stream__kernel__1.html#acacd3c0985a8c03ca04fc3b5dd51d770">bit_stream_kernel_1</a>&amp;);  <span class="comment">// assignment operator</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    };</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        bit_stream_kernel_1&amp; a, </div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        bit_stream_kernel_1&amp; b</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    );</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;}</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="preprocessor">#ifdef NO_MAKEFILE</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="preprocessor">#include &quot;bit_stream_kernel_1.cpp&quot;</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="preprocessor">#endif // DLIB_BIT_STREAM_KERNEl_1_</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1bit__stream__kernel__1_html_acacd3c0985a8c03ca04fc3b5dd51d770"><div class="ttname"><a href="classdlib_1_1bit__stream__kernel__1.html#acacd3c0985a8c03ca04fc3b5dd51d770">dlib::bit_stream_kernel_1::bit_stream_kernel_1</a></div><div class="ttdeci">bit_stream_kernel_1()</div><div class="ttdef"><b>Definition:</b> bit_stream_kernel_1.h:48</div></div>
<div class="ttc" id="aclassdlib_1_1bit__stream__kernel__1_html"><div class="ttname"><a href="classdlib_1_1bit__stream__kernel__1.html">dlib::bit_stream_kernel_1</a></div><div class="ttdef"><b>Definition:</b> bit_stream_kernel_1.h:12</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
